# FileList

Extends \DataType

FileList represents an explicitly named list of files. FileLists are useful when you want to capture a list of files regardless of whether they currently exist.

<filelist id="docfiles" dir="${phing.docs.dir}" files="chapters/Installation.html,chapters/Setup.html"/>

OR

<filelist dir="${doc.src.dir}" listfile="${phing.docs.dir}/PhingGuide.book"/>

(or a mixture of files="" and listfile="" can be used)

author | Hans Lellelid hans@xmpl.org
version | $Id: b578f5cdbe1b9022fae4187fe18769f1558a8a4e $
package | phing.types

### Methods

## Construct a new FileList.

    __construct(\FileList $filelist = null)

### Arguments

#### $filelist

`\FileList`

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Get the basedir for files in list.

    getDir(\Project $p) : \PhingFile

throws |

### Arguments

#### $p

`\Project`

### Response

`\PhingFile`

## Returns the list of files represented by this FileList.

    getFiles(\Project $p) : array

### Arguments

#### $p

`\Project`

### Response

`array`

## Get the source "list" file that contains file names.

    getListFile(\Project $p) : \PhingFile

### Arguments

#### $p

`\Project`

### Response

`\PhingFile`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Performs the check for circular references and returns the referenced FileSet.

    getRef(\Project $p) : \FileList

throws |

### Arguments

#### $p

`\Project`

### Response

`\FileList`

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## Reads file names from a file and adds them to the files array.

    readListFile(\Project $p)

throws |

### Arguments

#### $p

`\Project`

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## Base directory for files in list.

    setDir(\PhingFile $dir)

throws |

### Arguments

#### $dir

`\PhingFile`

## Set the array of files in list.

    setFiles(array $filenames)

throws |

### Arguments

#### $filenames

`array`

## Sets a source "list" file that contains filenames to add -- one per line.

    setListFile(string $file)

throws |

### Arguments

#### $file

`string`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

### Properties

## Array containing all filenames.

    filenames :

### Type(s)

``

## Base directory for this file list.

    dir :

### Type(s)

``

## that contains a list of files (one per line).

    listfile : \PhingFile

var | that contains a list of files (one per line).

### Type(s)

`\PhingFile`

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`